AuthenticatedSymmetricCipher Class Referenceabstract

Interface for one direction (encryption or decryption) of a stream cipher or block cipher mode with authentication. More...

Inheritance diagram for AuthenticatedSymmetricCipher:

## Classes

class | BadState
| Exception thrown when the object is in the wrong state for the operation. More...

## Public Member Functions

virtual lword | MaxHeaderLength () const =0
| Provides the maximum length of AAD that can be input. More...
virtual lword | MaxMessageLength () const =0
| Provides the maximum length of encrypted data. More...
virtual lword | MaxFooterLength () const
| Provides the the maximum length of AAD. More...
virtual bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data. More...
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prespecifies the data lengths. More...
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call. More...
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macLength, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call. More...
virtual std::string | AlgorithmName () const =0
| Provides the name of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length in bytes.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length in bytes.
virtual size_t | DefaultKeyLength () const =0
| Returns default (recommended) key length in bytes.
virtual size_t | GetValidKeyLength (size_t n) const =0
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Update (const byte *input, size_t length)=0
| Updates a hash with additional input. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
virtual void | Restart ()
| Restart the hash. More...
virtual unsigned int | DigestSize () const =0
| Provides the digest size of the hash. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | TruncatedFinal (byte *digest, size_t digestSize)=0
| Computes the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| Encrypt or decrypt an array of bytes. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsSelfInverting () const =0
| Determines whether the cipher is self-inverting. More...
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction. More...

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

Interface for one direction (encryption or decryption) of a stream cipher or block cipher mode with authentication.

The StreamTransformation part of this interface is used to encrypt/decrypt the data, and the MessageAuthenticationCode part of this interface is used to input additional authenticated data (AAD, which is MAC'ed but not encrypted), and to generate/verify the MAC.

Definition at line 1117 of file cryptlib.h.

## Member Function Documentation

## MaxHeaderLength()

virtual lword AuthenticatedSymmetricCipher::MaxHeaderLength | ( |  | ) | const

pure virtual

Provides the maximum length of AAD that can be input.

Returns
  the maximum length of AAD that can be input before the encrypted data

Implemented in GCM_Base, CCM_Base, and EAX_Base.

## MaxMessageLength()

virtual lword AuthenticatedSymmetricCipher::MaxMessageLength | ( |  | ) | const

pure virtual

Provides the maximum length of encrypted data.

Returns
  the maximum length of encrypted data

Implemented in GCM_Base, CCM_Base, and EAX_Base.

## MaxFooterLength()

virtual lword AuthenticatedSymmetricCipher::MaxFooterLength | ( |  | ) | const

inline virtual

Provides the the maximum length of AAD.

Returns
  the maximum length of AAD that can be input after the encrypted data

Definition at line 1142 of file cryptlib.h.

## NeedsPrespecifiedDataLengths()

virtual bool AuthenticatedSymmetricCipher::NeedsPrespecifiedDataLengths | ( |  | ) | const

inline virtual

Determines if data lengths must be specified prior to inputting data.

Returns
  true if the data lengths are required before inputting data, false otherwise

if this function returns true, SpecifyDataLengths() must be called before attempting to input data. This is the case for some schemes, such as CCM.

See also
  SpecifyDataLengths()

Reimplemented in CCM_Base.

Definition at line 1148 of file cryptlib.h.

## SpecifyDataLengths()

void AuthenticatedSymmetricCipher::SpecifyDataLengths | ( | lword | headerLength,
|  | lword | messageLength,
|  | lword | footerLength = `0`
| ) |  |

Prespecifies the data lengths.

this function only needs to be called if NeedsPrespecifiedDataLengths() returns true

See also
  NeedsPrespecifiedDataLengths()

Definition at line 258 of file cryptlib.cpp.

## EncryptAndAuthenticate()

void AuthenticatedSymmetricCipher::EncryptAndAuthenticate | ( | byte * | ciphertext,
|  | byte * | mac,
|  | size_t | macSize,
|  | const byte * | iv,
|  | int | ivLength,
|  | const byte * | header,
|  | size_t | headerLength,
|  | const byte * | message,
|  | size_t | messageLength
| ) |  |

virtual

Encrypts and calculates a MAC in one call.

Returns
  true if the authenticated encryption succeeded, false otherwise

EncryptAndAuthenticate() encrypts and generates the MAC in one call. The function will truncate MAC if `macSize < TagSize()`.

Definition at line 272 of file cryptlib.cpp.

## DecryptAndVerify()

bool AuthenticatedSymmetricCipher::DecryptAndVerify | ( | byte * | message,
|  | const byte * | mac,
|  | size_t | macLength,
|  | const byte * | iv,
|  | int | ivLength,
|  | const byte * | header,
|  | size_t | headerLength,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength
| ) |  |

virtual

Decrypts and verifies a MAC in one call.

Returns
  true if the MAC is valid and the decoding succeeded, false otherwise

DecryptAndVerify() decrypts and verifies the MAC in one call. The function returns true iff MAC is valid. DecryptAndVerify() will assume MAC is truncated if `macLength < TagSize()`.

Definition at line 281 of file cryptlib.cpp.

## AlgorithmName()

virtual std::string AuthenticatedSymmetricCipher::AlgorithmName | ( |  | ) | const

pure virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Reimplemented from Algorithm.

Implemented in GCM_Base, CCM_Base, and EAX_Base.

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp